# Namespace: browser_jools

## browser_jools

Source:
  - lib/browser_jools.js, line 1

### Members

#### (static) exports.version

version

Source:
  - lib/browser_jools.js, line 382

#### (static) require.resolve

Source:
  - lib/browser_jools.js, line 34

### Methods

#### (static) Jools(rules)

Jools constructor.

A rule consists of:

- Descriptive name
- One or more conditions
- One or more consequences, which are fired when all conditions evaluate to true.

##### Parameters:

Name | Type | Description
--- | --- | ---
`rules` | Object |

Source:
  - lib/browser_jools.js, line 394

#### (static) module.exports.paramNames(f)

Returns an array of parameter names of the function f

##### Parameters:

Name | Type | Description
--- | --- | ---
`f` | function |

Source:
  - lib/browser_jools.js, line 453

#### (static) module.exports.paramsToArguments(obj, params)

Creates an array of arguments

##### Parameters:

Name | Type | Description
--- | --- | ---
`obj` | Object |
`params` | Array |

Source:
  - lib/browser_jools.js, line 471

#### (static) normalizeArray(parts, allowAboveRoot)

resolves . and .. elements in a path array with directory names there must be no slashes, empty elements, or device names (c:) in the array (so also no leading and trailing slashes - it does not distinguish relative and absolute paths)

##### Parameters:

Name | Type | Description
--- | --- | ---
`parts` |  |
`allowAboveRoot` |  |

Source:
  - lib/browser_jools.js, line 242

#### (static) require(file, cwd)

##### Parameters:

Name | Type | Description
--- | --- | ---
`file` |  |
`cwd` |  |

Source:
  - lib/browser_jools.js, line 10

#### (static) require.alias()

Source:
  - lib/browser_jools.js, line 121

#### (static) require.define()

Source:
  - lib/browser_jools.js, line 152